local E, L, V, P, G, _ = unpack(ElvUI); --Import: Engine, Locales, PrivateDB, ProfileDB, GlobalDB, Localize Underscore
local ElvUF = ElvUI.oUF

-- Cache global variables
-- WoW API / Variables
local strfind, strmatch, utf8lower, utf8sub = strfind, strmatch, string.utf8lower, string.utf8sub
local gmatch, gsub, format = gmatch, gsub, format
local UnitName = UnitName
local UnitHealth = UnitHealth
local UnitHealthMax = UnitHealthMax
local UnitIsAFK = UnitIsAFK
local UnitIsConnected = UnitIsConnected
local UnitIsDead = UnitIsDead
local UnitIsGhost = UnitIsGhost
local UnitPower = UnitPower
local UnitPowerMax = UnitPowerMax
local UnitGetIncomingHeals = UnitGetIncomingHeals
local UnitGetTotalAbsorbs = UnitGetTotalAbsorbs
local UnitClass = UnitClass
local strupper = strupper


ElvUF.Tags.Events['kmt-deficit:name-long'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-deficit:name-long'] = function(unit)
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local deficit = UnitHealthMax(unit) - currentHealth
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return status
	elseif (deficit > 0 and currentHealth > 0) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return name ~= nil and E:ShortenString(name, 20) or nil
	end
end

ElvUF.Tags.Events['kmt-deficit:name-medium'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-deficit:name-medium'] = function(unit)
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local deficit = UnitHealthMax(unit) - currentHealth
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return status
	elseif (deficit > 0 and currentHealth > 0) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return name ~= nil and E:ShortenString(name, 15) or nil
	end
end

ElvUF.Tags.Events['kmt-deficit:name-short'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-deficit:name-short'] = function(unit)
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local deficit = UnitHealthMax(unit) - currentHealth
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return status
	elseif (deficit > 0 and currentHealth > 0) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return name ~= nil and E:ShortenString(name, 10) or nil
	end
end

ElvUF.Tags.Events['kmt-deficit:name-veryshort'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-deficit:name-veryshort'] = function(unit)
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local deficit = UnitHealthMax(unit) - currentHealth
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return status
	elseif (deficit > 0 and currentHealth > 0) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return name ~= nil and E:ShortenString(name, 5) or nil
	end
end


ElvUF.Tags.Events['kmt-deficit:name-long:caps'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-deficit:name-long:caps'] = function(unit)
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local cname = strupper(name)
	local deficit = UnitHealthMax(unit) - currentHealth
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return strupper(status)
	elseif (deficit > 0 and currentHealth > 0) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return cname ~= nil and E:ShortenString(cname, 20) or nil
	end
end

ElvUF.Tags.Events['kmt-deficit:name-medium:caps'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-deficit:name-medium:caps'] = function(unit)
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local cname = strupper(name)
	local deficit = UnitHealthMax(unit) - currentHealth
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return strupper(status)
	elseif (deficit > 0 and currentHealth > 0) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return cname ~= nil and E:ShortenString(cname, 15) or nil
	end
end

ElvUF.Tags.Events['kmt-deficit:name-short:caps'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-deficit:name-short:caps'] = function(unit)
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local cname = strupper(name)
	local deficit = UnitHealthMax(unit) - currentHealth
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return strupper(status)
	elseif (deficit > 0 and currentHealth > 0) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return cname ~= nil and E:ShortenString(cname, 10) or nil
	end
end

ElvUF.Tags.Events['kmt-deficit:name-veryshort:caps'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-deficit:name-veryshort:caps'] = function(unit)
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local cname = strupper(name)
	local deficit = UnitHealthMax(unit) - currentHealth
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return strupper(status)
	elseif (deficit > 0 and currentHealth > 0) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return cname ~= nil and E:ShortenString(cname, 5) or nil
	end
end

ElvUF.Tags.Events['kmt-deficit:name-long:nostatus'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-deficit:name-long:nostatus'] = function(unit)
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local deficit = UnitHealthMax(unit) - currentHealth
	if (deficit > 0 and currentHealth > 0) and not (UnitIsGhost(unit) and L["Ghost"]) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return name ~= nil and E:ShortenString(name, 20) or nil
	end
end

ElvUF.Tags.Events['kmt-deficit:name-medium:nostatus'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-deficit:name-medium:nostatus'] = function(unit)
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local deficit = UnitHealthMax(unit) - currentHealth
	if (deficit > 0 and currentHealth > 0) and not (UnitIsGhost(unit) and L["Ghost"]) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return name ~= nil and E:ShortenString(name, 15) or nil
	end
end

ElvUF.Tags.Events['kmt-deficit:name-short:nostatus'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-deficit:name-short:nostatus'] = function(unit)
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local deficit = UnitHealthMax(unit) - currentHealth
	if (deficit > 0 and currentHealth > 0) and not (UnitIsGhost(unit) and L["Ghost"]) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return name ~= nil and E:ShortenString(name, 10) or nil
	end
end

ElvUF.Tags.Events['kmt-deficit:name-veryshort:nostatus'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-deficit:name-veryshort:nostatus'] = function(unit)
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local deficit = UnitHealthMax(unit) - currentHealth
	if (deficit > 0 and currentHealth > 0) and not (UnitIsGhost(unit) and L["Ghost"]) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return name ~= nil and E:ShortenString(name, 5) or nil
	end
end

ElvUF.Tags.Events['kmt-deficit:name-long:nostatus:caps'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-deficit:name-long:nostatus:caps'] = function(unit)
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local cname = strupper(name)
	local deficit = UnitHealthMax(unit) - currentHealth
	if (deficit > 0 and currentHealth > 0) and not (UnitIsGhost(unit) and L["Ghost"]) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return cname ~= nil and E:ShortenString(cname, 20) or nil
	end
end

ElvUF.Tags.Events['kmt-deficit:name-medium:nostatus:caps'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-deficit:name-medium:nostatus:caps'] = function(unit)
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local cname = strupper(name)
	local deficit = UnitHealthMax(unit) - currentHealth
	if (deficit > 0 and currentHealth > 0) and not (UnitIsGhost(unit) and L["Ghost"]) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return cname ~= nil and E:ShortenString(cname, 15) or nil
	end
end

ElvUF.Tags.Events['kmt-deficit:name-short:nostatus:caps'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-deficit:name-short:nostatus:caps'] = function(unit)
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local cname = strupper(name)
	local deficit = UnitHealthMax(unit) - currentHealth
	if (deficit > 0 and currentHealth > 0) and not (UnitIsGhost(unit) and L["Ghost"]) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return cname ~= nil and E:ShortenString(cname, 10) or nil
	end
end

ElvUF.Tags.Events['kmt-deficit:name-veryshort:nostatus:caps'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-deficit:name-veryshort:nostatus:caps'] = function(unit)
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local cname = strupper(name)
	local deficit = UnitHealthMax(unit) - currentHealth
	if (deficit > 0 and currentHealth > 0) and not (UnitIsGhost(unit) and L["Ghost"]) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return cname ~= nil and E:ShortenString(cname, 5) or nil
	end
end

ElvUF.Tags.Events['kmt-pheal:long'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_HEAL_PREDICTION UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-pheal:long'] = function(unit)
	local heal = UnitGetIncomingHeals(unit, 'player') or 0
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local maxHealth = UnitHealthMax(unit)
	local deficit = UnitHealthMax(unit) - currentHealth
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return status
	elseif heal ~= 0 and currentHealth ~= maxHealth then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))  .. " | " ..  format('|cff00ff00+%s|r', E:ShortValue(heal))
	elseif (deficit > 0 and currentHealth > 0) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return name ~= nil and E:ShortenString(name, 20) or nil
	end
end

ElvUF.Tags.Events['kmt-pheal:medium'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_HEAL_PREDICTION UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-pheal:medium'] = function(unit)
	local heal = UnitGetIncomingHeals(unit, 'player') or 0
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local maxHealth = UnitHealthMax(unit)
	local deficit = UnitHealthMax(unit) - currentHealth
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return status
	elseif heal ~= 0 and currentHealth ~= maxHealth then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))  .. " | " ..  format('|cff00ff00+%s|r', E:ShortValue(heal))
	elseif (deficit > 0 and currentHealth > 0) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return name ~= nil and E:ShortenString(name, 15) or nil
	end
end

ElvUF.Tags.Events['kmt-pheal:short'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_HEAL_PREDICTION UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-pheal:short'] = function(unit)
	local heal = UnitGetIncomingHeals(unit, 'player') or 0
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local maxHealth = UnitHealthMax(unit)
	local deficit = UnitHealthMax(unit) - currentHealth
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return status
	elseif heal ~= 0 and currentHealth ~= maxHealth then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))  .. " | " ..  format('|cff00ff00+%s|r', E:ShortValue(heal))
	elseif (deficit > 0 and currentHealth > 0) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return name ~= nil and E:ShortenString(name, 10) or nil
	end
end

ElvUF.Tags.Events['kmt-pheal:veryshort'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_HEAL_PREDICTION UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-pheal:veryshort'] = function(unit)
	local heal = UnitGetIncomingHeals(unit, 'player') or 0
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local maxHealth = UnitHealthMax(unit)
	local deficit = UnitHealthMax(unit) - currentHealth
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return status
	elseif heal ~= 0 and currentHealth ~= maxHealth then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))  .. " | " ..  format('|cff00ff00+%s|r', E:ShortValue(heal))
	elseif (deficit > 0 and currentHealth > 0) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return name ~= nil and E:ShortenString(name, 5) or nil
	end
end

ElvUF.Tags.Events['kmt-pheal:long:caps'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_HEAL_PREDICTION UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-pheal:long:caps'] = function(unit)
	local heal = UnitGetIncomingHeals(unit, 'player') or 0
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local cname = strupper(name)
	local maxHealth = UnitHealthMax(unit)
	local deficit = UnitHealthMax(unit) - currentHealth
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return strupper(status)
	elseif heal ~= 0 and currentHealth ~= maxHealth then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))  .. " | " ..  format('|cff00ff00+%s|r', E:ShortValue(heal))
	elseif (deficit > 0 and currentHealth > 0) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return cname ~= nil and E:ShortenString(cname, 20) or nil
	end
end

ElvUF.Tags.Events['kmt-pheal:medium:caps'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_HEAL_PREDICTION UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-pheal:medium:caps'] = function(unit)
	local heal = UnitGetIncomingHeals(unit, 'player') or 0
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local cname = strupper(name)
	local maxHealth = UnitHealthMax(unit)
	local deficit = UnitHealthMax(unit) - currentHealth
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return strupper(status)
	elseif heal ~= 0 and currentHealth ~= maxHealth then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))  .. " | " ..  format('|cff00ff00+%s|r', E:ShortValue(heal))
	elseif (deficit > 0 and currentHealth > 0) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return cname ~= nil and E:ShortenString(cname, 15) or nil
	end
end

ElvUF.Tags.Events['kmt-pheal:short:caps'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_HEAL_PREDICTION UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-pheal:short:caps'] = function(unit)
	local heal = UnitGetIncomingHeals(unit, 'player') or 0
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local cname = strupper(name)
	local maxHealth = UnitHealthMax(unit)
	local deficit = UnitHealthMax(unit) - currentHealth
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return strupper(status)
	elseif heal ~= 0 and currentHealth ~= maxHealth then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))  .. " | " ..  format('|cff00ff00+%s|r', E:ShortValue(heal))
	elseif (deficit > 0 and currentHealth > 0) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return cname ~= nil and E:ShortenString(cname, 10) or nil
	end
end

ElvUF.Tags.Events['kmt-pheal:veryshort:caps'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_HEAL_PREDICTION UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-pheal:veryshort:caps'] = function(unit)
	local heal = UnitGetIncomingHeals(unit, 'player') or 0
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local cname = strupper(name)
	local maxHealth = UnitHealthMax(unit)
	local deficit = UnitHealthMax(unit) - currentHealth
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return strupper(status)
	elseif heal ~= 0 and currentHealth ~= maxHealth then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))  .. " | " ..  format('|cff00ff00+%s|r', E:ShortValue(heal))
	elseif (deficit > 0 and currentHealth > 0) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return cname ~= nil and E:ShortenString(cname, 5) or nil
	end
end

ElvUF.Tags.Events['kmt-heal:long'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_HEAL_PREDICTION UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-heal:long'] = function(unit)
	local heal = UnitGetIncomingHeals(unit) or 0
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local maxHealth = UnitHealthMax(unit)
	local deficit = UnitHealthMax(unit) - currentHealth
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return status
	elseif heal ~= 0 and currentHealth ~= maxHealth then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))  .. " | " ..  format('|cff00ff00+%s|r', E:ShortValue(heal))
	elseif (deficit > 0 and currentHealth > 0) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return name ~= nil and E:ShortenString(name, 20) or nil
	end
end

ElvUF.Tags.Events['kmt-heal:medium'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_HEAL_PREDICTION UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-heal:medium'] = function(unit)
	local heal = UnitGetIncomingHeals(unit) or 0
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local maxHealth = UnitHealthMax(unit)
	local deficit = UnitHealthMax(unit) - currentHealth
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return status
	elseif heal ~= 0 and currentHealth ~= maxHealth then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))  .. " | " ..  format('|cff00ff00+%s|r', E:ShortValue(heal))
	elseif (deficit > 0 and currentHealth > 0) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return name ~= nil and E:ShortenString(name, 15) or nil
	end
end

ElvUF.Tags.Events['kmt-heal:short'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_HEAL_PREDICTION UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-heal:short'] = function(unit)
	local heal = UnitGetIncomingHeals(unit) or 0
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local maxHealth = UnitHealthMax(unit)
	local deficit = UnitHealthMax(unit) - currentHealth
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return status
	elseif heal ~= 0 and currentHealth ~= maxHealth then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))  .. " | " ..  format('|cff00ff00+%s|r', E:ShortValue(heal))
	elseif (deficit > 0 and currentHealth > 0) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return name ~= nil and E:ShortenString(name, 10) or nil
	end
end

ElvUF.Tags.Events['kmt-heal:veryshort'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_HEAL_PREDICTION UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-heal:veryshort'] = function(unit)
	local heal = UnitGetIncomingHeals(unit) or 0
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local maxHealth = UnitHealthMax(unit)
	local deficit = UnitHealthMax(unit) - currentHealth
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return status
	elseif heal ~= 0 and currentHealth ~= maxHealth then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))  .. " | " ..  format('|cff00ff00+%s|r', E:ShortValue(heal))
	elseif (deficit > 0 and currentHealth > 0) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return name ~= nil and E:ShortenString(name, 5) or nil
	end
end

ElvUF.Tags.Events['kmt-heal:long:caps'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_HEAL_PREDICTION UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-heal:long:caps'] = function(unit)
	local heal = UnitGetIncomingHeals(unit) or 0
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local cname = strupper(name)
	local maxHealth = UnitHealthMax(unit)
	local deficit = UnitHealthMax(unit) - currentHealth
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return strupper(status)
	elseif heal ~= 0 and currentHealth ~= maxHealth then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))  .. " | " ..  format('|cff00ff00+%s|r', E:ShortValue(heal))
	elseif (deficit > 0 and currentHealth > 0) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return cname ~= nil and E:ShortenString(cname, 20) or nil
	end
end

ElvUF.Tags.Events['kmt-heal:medium:caps'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_HEAL_PREDICTION UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-heal:medium:caps'] = function(unit)
	local heal = UnitGetIncomingHeals(unit) or 0
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local cname = strupper(name)
	local maxHealth = UnitHealthMax(unit)
	local deficit = UnitHealthMax(unit) - currentHealth
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return strupper(status)
	elseif heal ~= 0 and currentHealth ~= maxHealth then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))  .. " | " ..  format('|cff00ff00+%s|r', E:ShortValue(heal))
	elseif (deficit > 0 and currentHealth > 0) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return cname ~= nil and E:ShortenString(cname, 15) or nil
	end
end

ElvUF.Tags.Events['kmt-heal:short:caps'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_HEAL_PREDICTION UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-heal:short:caps'] = function(unit)
	local heal = UnitGetIncomingHeals(unit) or 0
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local cname = strupper(name)
	local maxHealth = UnitHealthMax(unit)
	local deficit = UnitHealthMax(unit) - currentHealth
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return strupper(status)
	elseif heal ~= 0 and currentHealth ~= maxHealth then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))  .. " | " ..  format('|cff00ff00+%s|r', E:ShortValue(heal))
	elseif (deficit > 0 and currentHealth > 0) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return cname ~= nil and E:ShortenString(cname, 10) or nil
	end
end

ElvUF.Tags.Events['kmt-heal:veryshort:caps'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_NAME_UPDATE UNIT_HEAL_PREDICTION UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-heal:veryshort:caps'] = function(unit)
	local heal = UnitGetIncomingHeals(unit) or 0
	local currentHealth = UnitHealth(unit)
	local name = UnitName(unit)
	local cname = strupper(name)
	local maxHealth = UnitHealthMax(unit)
	local deficit = UnitHealthMax(unit) - currentHealth
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return strupper(status)
	elseif heal ~= 0 and currentHealth ~= maxHealth then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))  .. " | " ..  format('|cff00ff00+%s|r', E:ShortValue(heal))
	elseif (deficit > 0 and currentHealth > 0) then
		return E:GetFormattedText('DEFICIT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return cname ~= nil and E:ShortenString(cname, 5) or nil
	end
end

ElvUF.Tags.Events['kmt-manaper:hidefull'] = 'UNIT_POWER_FREQUENT UNIT_MAXPOWER'
ElvUF.Tags.Methods['kmt-manaper:hidefull'] = function(unit)
	local cur = UnitPower(unit, 0)
	local max = UnitPowerMax(unit, 0)

	if cur == max then
		return nil
	else
		return E:GetFormattedText('PERCENT', cur, UnitPowerMax(unit, 0))
	end
end

ElvUF.Tags.Events['kmt-health:absorb'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_ABSORB_AMOUNT_CHANGED UNIT_CONNECTION PLAYER_FLAGS_CHANGED UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-health:absorb'] = function(unit)
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	local absorb = UnitGetTotalAbsorbs(unit) or 0
	local tHealth = UnitHealth(unit) + absorb
	if (status) then
		return status
	elseif	absorb == 0 then
		return  E:GetFormattedText('CURRENT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return format('|cffccff33%s|r', E:GetFormattedText('CURRENT', tHealth, UnitHealthMax(unit)))
	end
end

ElvUF.Tags.Events['kmt-health:current:percent-hidefull'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_CONNECTION PLAYER_FLAGS_CHANGED UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-health:current:percent-hidefull'] = function(unit)
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	local CurrentPercent = (UnitHealth(unit)/UnitHealthMax(unit))*100
		if (status) then
			return status
		else
	if CurrentPercent == 100 then
		return E:GetFormattedText('CURRENT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return E:GetFormattedText('CURRENT', UnitHealth(unit), UnitHealthMax(unit)) .. " | " .. format("%.0f%%", CurrentPercent)
	end
	end
end

ElvUF.Tags.Events['kmt-health:current2:percent-hidefull'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_CONNECTION PLAYER_FLAGS_CHANGED UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-health:current2:percent-hidefull'] = function(unit)
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	local CurrentPercent = (UnitHealth(unit)/UnitHealthMax(unit))*100
		if (status) then
			return status
		else
	if CurrentPercent == 100 then
		return E:GetFormattedText('CURRENT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return format("%.0f%%", CurrentPercent) .. " | " .. E:GetFormattedText('CURRENT', UnitHealth(unit), UnitHealthMax(unit))
	end
	end
end

ElvUF.Tags.Events['kmt-percent:name-long'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_CONNECTION PLAYER_FLAGS_CHANGED UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-percent:name-long'] = function(unit)
	local name = UnitName(unit)
	local CurrentPercent = (UnitHealth(unit)/UnitHealthMax(unit))*100
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return status
	elseif CurrentPercent == 100 then
		return name ~= nil and E:ShortenString(name, 20) or nil
	else
		return E:GetFormattedText('PERCENT', UnitHealth(unit), UnitHealthMax(unit))
	end
end

ElvUF.Tags.Events['kmt-percent:name-medium'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_CONNECTION PLAYER_FLAGS_CHANGED UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-percent:name-medium'] = function(unit)
	local name = UnitName(unit)
	local CurrentPercent = (UnitHealth(unit)/UnitHealthMax(unit))*100
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return status
	elseif CurrentPercent == 100 then
		return name ~= nil and E:ShortenString(name, 15) or nil
	else
		return E:GetFormattedText('PERCENT', UnitHealth(unit), UnitHealthMax(unit))
	end
end

ElvUF.Tags.Events['kmt-percent:name-short'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_CONNECTION PLAYER_FLAGS_CHANGED UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-percent:name-short'] = function(unit)
	local name = UnitName(unit)
	local CurrentPercent = (UnitHealth(unit)/UnitHealthMax(unit))*100
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return status
	elseif CurrentPercent == 100 then
		return name ~= nil and E:ShortenString(name, 10) or nil
	else
		return E:GetFormattedText('PERCENT', UnitHealth(unit), UnitHealthMax(unit))
	end
end

ElvUF.Tags.Events['kmt-percent:name-veryshort'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_CONNECTION PLAYER_FLAGS_CHANGED UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-percent:name-veryshort'] = function(unit)
	local name = UnitName(unit)
	local CurrentPercent = (UnitHealth(unit)/UnitHealthMax(unit))*100
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return status
	elseif CurrentPercent == 100 then
		return name ~= nil and E:ShortenString(name, 5) or nil
	else
		return E:GetFormattedText('PERCENT', UnitHealth(unit), UnitHealthMax(unit))
	end
end

ElvUF.Tags.Events['kmt-percent:name-long:caps'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_CONNECTION PLAYER_FLAGS_CHANGED UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-percent:name-long:caps'] = function(unit)
	local name = UnitName(unit)
	local cname = strupper(name)
	local CurrentPercent = (UnitHealth(unit)/UnitHealthMax(unit))*100
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return strupper(status)
	elseif CurrentPercent == 100 then
		return cname ~= nil and E:ShortenString(cname, 20) or nil
	else
		return E:GetFormattedText('PERCENT', UnitHealth(unit), UnitHealthMax(unit))
	end
end

ElvUF.Tags.Events['kmt-percent:name-medium:caps'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_CONNECTION PLAYER_FLAGS_CHANGED UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-percent:name-medium:caps'] = function(unit)
	local name = UnitName(unit)
	local cname = strupper(name)
	local CurrentPercent = (UnitHealth(unit)/UnitHealthMax(unit))*100
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return strupper(status)
	elseif CurrentPercent == 100 then
		return cname ~= nil and E:ShortenString(cname, 15) or nil
	else
		return E:GetFormattedText('PERCENT', UnitHealth(unit), UnitHealthMax(unit))
	end
end

ElvUF.Tags.Events['kmt-percent:name-short:caps'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_CONNECTION PLAYER_FLAGS_CHANGED UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-percent:name-short:caps'] = function(unit)
	local name = UnitName(unit)
	local cname = strupper(name)
	local CurrentPercent = (UnitHealth(unit)/UnitHealthMax(unit))*100
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return strupper(status)
	elseif CurrentPercent == 100 then
		return cname ~= nil and E:ShortenString(cname, 10) or nil
	else
		return E:GetFormattedText('PERCENT', UnitHealth(unit), UnitHealthMax(unit))
	end
end

ElvUF.Tags.Events['kmt-percent:name-veryshort:caps'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_CONNECTION PLAYER_FLAGS_CHANGED UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-percent:name-veryshort:caps'] = function(unit)
	local name = UnitName(unit)
	local cname = strupper(name)
	local CurrentPercent = (UnitHealth(unit)/UnitHealthMax(unit))*100
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return strupper(status)
	elseif CurrentPercent == 100 then
		return cname ~= nil and E:ShortenString(cname, 5) or nil
	else
		return E:GetFormattedText('PERCENT', UnitHealth(unit), UnitHealthMax(unit))
	end
end

ElvUF.Tags.Events['kmt-status:name-long'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_CONNECTION PLAYER_FLAGS_CHANGED UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-status:name-long'] = function(unit)
	local name = UnitName(unit)
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return status
	else
		return name ~= nil and E:ShortenString(name, 20) or nil
	end
end

ElvUF.Tags.Events['kmt-status:name-medium'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_CONNECTION PLAYER_FLAGS_CHANGED UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-status:name-medium'] = function(unit)
	local name = UnitName(unit)
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return status
	else
		return name ~= nil and E:ShortenString(name, 15) or nil
	end
end

ElvUF.Tags.Events['kmt-status:name-short'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_CONNECTION PLAYER_FLAGS_CHANGED UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-status:name-short'] = function(unit)
	local name = UnitName(unit)
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return status
	else
		return name ~= nil and E:ShortenString(name, 10) or nil
	end
end

ElvUF.Tags.Events['kmt-status:name-veryshort'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_CONNECTION PLAYER_FLAGS_CHANGED UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-status:name-veryshort'] = function(unit)
	local name = UnitName(unit)
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return status
	else
		return name ~= nil and E:ShortenString(name, 5) or nil
	end
end

ElvUF.Tags.Events['kmt-status:name-long:caps'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_CONNECTION PLAYER_FLAGS_CHANGED UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-status:name-long:caps'] = function(unit)
	local name = UnitName(unit)
	local cname = strupper(name)
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return strupper(status)
	else
		return cname ~= nil and E:ShortenString(cname, 20) or nil
	end
end

ElvUF.Tags.Events['kmt-status:name-medium:caps'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_CONNECTION PLAYER_FLAGS_CHANGED UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-status:name-medium:caps'] = function(unit)
	local name = UnitName(unit)
	local cname = strupper(name)
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return strupper(status)
	else
		return cname ~= nil and E:ShortenString(cname, 15) or nil
	end
end

ElvUF.Tags.Events['kmt-status:name-short:caps'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_CONNECTION PLAYER_FLAGS_CHANGED UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-status:name-short:caps'] = function(unit)
	local name = UnitName(unit)
	local cname = strupper(name)
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return strupper(status)
	else
		return cname ~= nil and E:ShortenString(cname, 10) or nil
	end
end

ElvUF.Tags.Events['kmt-status:name-veryshort:caps'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_CONNECTION PLAYER_FLAGS_CHANGED UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-status:name-veryshort:caps'] = function(unit)
	local name = UnitName(unit)
	local cname = strupper(name)
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	if (status) then
		return strupper(status)
	else
		return cname ~= nil and E:ShortenString(cname, 5) or nil
	end
end

ElvUF.Tags.Events['kmt-dead'] = 'UNIT_HEALTH_FREQUENT UNIT_CONNECTION PLAYER_FLAGS_CHANGED UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-dead'] = function(unit)
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"]
	local icon
	
	if (status) then
		icon = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\dead:0:0:0:0|t"
	else
		icon = nil
	end
	
	return icon
end

ElvUF.Tags.Events['kmt-classicon'] = 'UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-classicon'] = function(unit)
	local unitPlayer = UnitIsPlayer(unit)
	local classicon
	if (unitPlayer) then
		local _, unitClass = UnitClass(unit) 
			if unitClass == 'WARRIOR' then
				classicon = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\classes\\warrior:0:0:0:0|t"
			elseif unitClass == 'PALADIN' then
				classicon = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\classes\\paladin:0:0:0:0|t"
			elseif unitClass == 'HUNTER' then
				classicon = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\classes\\hunter:0:0:0:0|t"
			elseif unitClass == 'ROGUE' then
				classicon = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\classes\\rogue:0:0:0:0|t"
			elseif unitClass == 'PRIEST' then
				classicon = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\classes\\priest:0:0:0:0|t"
			elseif unitClass == 'DEATHKNIGHT' then
				classicon = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\classes\\deathknight:0:0:0:0|t"
			elseif unitClass == 'SHAMAN' then
				classicon = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\classes\\shaman:0:0:0:0|t"
			elseif unitClass == 'MAGE' then
				classicon = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\classes\\mage:0:0:0:0|t"
			elseif unitClass == 'WARLOCK' then
				classicon = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\classes\\warlock:0:0:0:0|t"
			elseif unitClass == 'MONK' then
				classicon = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\classes\\monk:0:0:0:0|t"
			elseif unitClass == 'DRUID' then
				classicon = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\classes\\druid:0:0:0:0|t"
			elseif unitClass == 'DEMONHUNTER' then
				classicon = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\classes\\demonhunter:0:0:0:0|t"
			end
	else
		classicon = nil
	end
	
	return classicon
end

ElvUF.Tags.Events['kmt-classicon2'] = 'UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-classicon2'] = function(unit)
	local unitPlayer = UnitIsPlayer(unit)
	local classicont
	--if (unitPlayer) then
	local _, unitClass = UnitClass(unit) 
			if unitClass == 'WARRIOR' then
				classicont = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\classest\\warrior:0:0:0:0|t"
			elseif unitClass == 'PALADIN' then
				classicont = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\classest\\paladin:0:0:0:0|t"
			elseif unitClass == 'HUNTER' then
				classicont = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\classest\\hunter:0:0:0:0|t"
			elseif unitClass == 'ROGUE' then
				classicont = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\classest\\rogue:0:0:0:0|t"
			elseif unitClass == 'PRIEST' then
				classicont = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\classest\\priest:0:0:0:0|t"
			elseif unitClass == 'DEATHKNIGHT' then
				classicont = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\classest\\deathknight:0:0:0:0|t"
			elseif unitClass == 'SHAMAN' then
				classicont = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\classest\\shaman:0:0:0:0|t"
			elseif unitClass == 'MAGE' then
				classicont = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\classest\\mage:0:0:0:0|t"
			elseif unitClass == 'WARLOCK' then
				classicont = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\classest\\warlock:0:0:0:0|t"
			elseif unitClass == 'MONK' then
				classicont = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\classest\\monk:0:0:0:0|t"
			elseif unitClass == 'DRUID' then
				classicont = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\classest\\druid:0:0:0:0|t"
			elseif unitClass == 'DEMONHUNTER' then
				classicont = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\classest\\demonhunter:0:0:0:0|t"
	else
		classicont = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\classest\\unknown:0:0:0:0|t"
	end
	
	return classicont
end


ElvUF.Tags.Events['kmt-classcrest'] = 'UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-classcrest'] = function(unit)
	local unitPlayer = UnitIsPlayer(unit)
	local classcrest
	if (unitPlayer) then
		local _, unitClass = UnitClass(unit) 
			if unitClass == 'WARRIOR' then
				classcrest = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\crests\\warrior:0:0:0:0|t"
			elseif unitClass == 'PALADIN' then
				classcrest = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\crests\\paladin:0:0:0:0|t"
			elseif unitClass == 'HUNTER' then
				classcrest = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\crests\\hunter:0:0:0:0|t"
			elseif unitClass == 'ROGUE' then
				classcrest = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\crests\\rogue:0:0:0:0|t"
			elseif unitClass == 'PRIEST' then
				classcrest = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\crests\\priest:0:0:0:0|t"
			elseif unitClass == 'DEATHKNIGHT' then
				classcrest = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\crests\\deathknight:0:0:0:0|t"
			elseif unitClass == 'SHAMAN' then
				classcrest = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\crests\\shaman:0:0:0:0|t"
			elseif unitClass == 'MAGE' then
				classcrest = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\crests\\mage:0:0:0:0|t"
			elseif unitClass == 'WARLOCK' then
				classcrest = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\crests\\warlock:0:0:0:0|t"
			elseif unitClass == 'MONK' then
				classcrest = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\crests\\monk:0:0:0:0|t"
			elseif unitClass == 'DRUID' then
				classcrest = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\crests\\druid:0:0:0:0|t"
			elseif unitClass == 'DEMONHUNTER' then
				classcrest = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\crests\\demonhunter:0:0:0:0|t"
			end
	else
		classcrest = nil
	end
	
	return classcrest
end


ElvUF.Tags.Events['kmt-powerper'] = 'UNIT_POWER_FREQUENT UNIT_MAXPOWER UNIT_DISPLAYPOWER UNIT_CONNECTION PLAYER_FLAGS_CHANGED'
ElvUF.Tags.Methods['kmt-powerper'] = function(unit)
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	local powerType = UnitPowerType(unit)
	local cur = UnitPower(unit, powerType)
	local max = UnitPowerMax(unit, powerType)
	local curper = (UnitPower(unit, powerType)/UnitPowerMax(unit, powerType))*100
	
	if (status) then
		return nil
	elseif powerType == 0 and cur == max then
		return nil
	elseif powerType ~= 0 and cur == 0 then
		return nil
	else
		return format("%.0f", curper)
	end
end

ElvUF.Tags.Events['kmt-healthper'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_CONNECTION PLAYER_FLAGS_CHANGED UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-healthper'] = function(unit)
	local status = UnitIsDead(unit) and L["Dead"] or UnitIsGhost(unit) and L["Ghost"] or not UnitIsConnected(unit) and L["Offline"]
	local CurrentHealth = UnitHealth(unit)
	local CurrentPercent = (UnitHealth(unit)/UnitHealthMax(unit))*100
	
	if (status) then
		return nil
	elseif CurrentPercent == 100 then
		return nil
	else
		return format("%.0f", CurrentPercent)
	end
end


ElvUF.Tags.Events['kmt-name:caps'] = 'UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-name:caps'] = function(unit)
	local name = UnitName(unit)
	local cname = strupper(name)
	return cname ~= nil and cname or nil
end

ElvUF.Tags.Events['kmt-name-long:caps'] = 'UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-name-long:caps'] = function(unit)
	local name = UnitName(unit)
	local cname = strupper(name)
	return cname ~= nil and E:ShortenString(cname, 20) or nil
end

ElvUF.Tags.Events['kmt-name-medium:caps'] = 'UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-name-medium:caps'] = function(unit)
	local name = UnitName(unit)
	local cname = strupper(name)
	return cname ~= nil and E:ShortenString(cname, 15) or nil
end

ElvUF.Tags.Events['kmt-name-short:caps'] = 'UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-name-short:caps'] = function(unit)
	local name = UnitName(unit)
	local cname = strupper(name)
	return cname ~= nil and E:ShortenString(cname, 10) or nil
end

ElvUF.Tags.Events['kmt-name-veryshort:caps'] = 'UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-name-veryshort:caps'] = function(unit)
	local name = UnitName(unit)
	local cname = strupper(name)
	return cname ~= nil and E:ShortenString(cname, 5) or nil
end

local function abbrev(name)
	local letters, lastWord = '', strmatch(name, '.+%s(.+)$')
	if lastWord then
		for word in gmatch(name, '.-%s') do
			local firstLetter = utf8sub(gsub(word, '^[%s%p]*', ''), 1, 1)
			if firstLetter ~= utf8lower(firstLetter) then
				letters = format('%s%s. ', letters, firstLetter)
			end
		end
		name = format('%s%s', letters, lastWord)
	end
	return name
end

ElvUF.Tags.Events['kmt-name:abbrev:caps'] = 'UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-name:abbrev:caps'] = function(unit)
	local name = UnitName(unit)

	if name and strfind(name, '%s') then
		name = abbrev(name)
	end
	name = strupper(name)
	
	return name ~= nil and E:ShortenString(name, 14) or '' --The value 20 controls how many characters are allowed in the name before it gets truncated. Change it to fit your needs.
end

ElvUF.Tags.Events['kmt-manaper-healer'] = 'UNIT_POWER_FREQUENT UNIT_MAXPOWER UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-manaper-healer'] = function(unit)
	local cur = UnitPower(unit, 0)
	local max = UnitPowerMax(unit, 0)
	local CurrentPercent = (cur/max)*100
	local role = UnitGroupRolesAssigned(unit)

	if role == 'HEALER' and cur ~= max then
		return format("%.0f", CurrentPercent)
	else
		return nil
	end
end

ElvUF.Tags.Events['kmt-manaper-healer2'] = 'UNIT_POWER_FREQUENT UNIT_MAXPOWER UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-manaper-healer2'] = function(unit)
	local cur = UnitPower(unit, 0)
	local max = UnitPowerMax(unit, 0)
	local CurrentPercent = (cur/max)*100
	local unitPlayer = UnitIsPlayer(unit)
	local _, unitClass = UnitClass(unit) 
	local role = UnitGroupRolesAssigned(unit)
			
	if (unitClass == 'PRIEST' or unitClass == 'PALADIN' or unitClass == 'MONK' or unitClass =='DRUID' or unitClass == 'SHAMAN') and (role == 'HEALER' or role == 'NONE') and cur ~= max then
		return format("%.0f", CurrentPercent)
	else
		return nil
	end
end

ElvUF.Tags.Events['kmt-health:current:percent-sw'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_CONNECTION PLAYER_FLAGS_CHANGED UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['kmt-health:current:percent-sw'] = function(unit)
	local CurrentPercent = (UnitHealth(unit)/UnitHealthMax(unit))*100
	if CurrentPercent == 100 then
		return E:GetFormattedText('CURRENT', UnitHealth(unit), UnitHealthMax(unit))
	else
		return format("%.0f%%", CurrentPercent)
	end
end

--[[
ElvUF.Tags.Events['kmt-role'] = 'PLAYER_ROLES_ASSIGNED GROUP_ROSTER_UPDATE'
ElvUF.Tags.Methods['kmt-role'] = function(unit)
	local role = UnitGroupRolesAssigned(unit)
	local roleicon
	if role == 'HEALER' then
			roleicon = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\roles\\heal:0:0:0:0|t"
	elseif role =='TANK' then
			roleicon = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\roles\\tank:0:0:0:0|t"
	elseif role =='DAMAGER' then 
			roleicon = "|TInterface\\AddOns\\ElvUI_KMediaTags\\tags\\media\\roles\\dps:0:0:0:0|t"
	else
		roleicon = nil
	end
	
	return roleicon
end]]--